import { int, Nullable, uint } from "./types";
export declare function $ascii(source: Nullable<string>): string;
/**
 *   We don't use standard trim because it does not trim all unicode whitespaces!
 */
export declare function $ltrim(s: Nullable<string>): string;
export declare function $rtrim(s: Nullable<string>): string;
export declare function $ftrim(s: Nullable<string>): string;
export { $ftrim as $trim };
export declare function $lines(s: Nullable<string>, useOnlyASCIISeparators?: boolean): string[];
export declare function $normspaces(s: Nullable<string>): string;
export declare function $firstcap(s: Nullable<string>): string;
export declare function $capitalize(s: Nullable<string>): string;
export declare function $HTML(s: Nullable<string>, reference?: string[]): string;
export declare class HTMLContent extends String {
}
declare global {
    export interface String {
        toHTML: (this: string) => string;
        toHTMLContent: (this: string) => HTMLContent;
        ascii: (this: string) => string;
        firstCap: (this: string) => string;
        capitalize: (this: string) => string;
        normalizeSpaces: (this: string) => string;
        ftrim: (this: string) => string;
        ltrim: (this: string) => string;
        rtrim: (this: string) => string;
        isDate: (this: string) => boolean;
        isEmail: (this: string) => boolean;
        isUrl: (this: string) => boolean;
        isUUID: (this: string) => boolean;
        lines: (this: string, useOnlyASCIISeparators?: boolean) => string[];
        toInt: (this: string, defaultValue?: int) => int;
        toUnsigned: (this: string, defaultValue?: uint) => uint;
        isNewLine: (this: string) => boolean;
        isWhiteSpace: (this: string) => boolean;
        isStrictWhiteSpace: (this: string) => boolean;
    }
    export interface HTMLContent {
        toHTML: (this: any) => string;
    }
}
